#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

#define WRITE_THREAD_CNT 1
#define BUF_SIZE 8192

int pipe_fd[2];

void dump(char* p, int len)
{
	for (int i = 0; i < len; i++)
		printf("%c ", *p++);
	printf("\n");
}

void *read_func(void*)
{
	printf("beg read_func\n"); fflush(stdout);
	char buf[BUF_SIZE];
	while (true)
	{
		int readLen = read(pipe_fd[0], buf, BUF_SIZE);
		if (readLen != BUF_SIZE)
		{
			printf("read return %d\n", readLen);
			break;
		}
		char ch = buf[0];
		for (int i = 0; i < readLen; i++)
		{
			if (ch != buf[i])
			{
				printf("diff!!!\n");
				dump(buf, readLen);
			}
		}
	}
	printf("end read_func\n"); fflush(stdout);
	return NULL;
}

void *write_func(void* p)
{
	int no = (intptr_t)p;
	printf("beg write_func %d\n", no); fflush(stdout);
	char buf[BUF_SIZE];
	for (int i = 0; i < BUF_SIZE; i++)
		buf[i] = no;
	while (true)
	{
		int writeLen = write(pipe_fd[1], buf, BUF_SIZE);
		if (writeLen != BUF_SIZE)
		{
			printf("writeLen return %d\n", writeLen);
			break;
		}
	}
	printf("end write_func %d\n", no); fflush(stdout);
	return NULL;
}

int main()
{
	pthread_t read_thread;
	pthread_t write_thread[WRITE_THREAD_CNT];

	pipe(pipe_fd);

	pthread_create(&read_thread, NULL, read_func, NULL);
	for (int i = 0; i < WRITE_THREAD_CNT; i++)
	{
		pthread_create(&write_thread[i], NULL, write_func, (void*)(intptr_t)(i + 'A'));
	}

	pthread_join(read_thread, NULL);
	for (int i = 0; i < WRITE_THREAD_CNT; i++)
		pthread_join(write_thread[i], NULL);
}
